###################################################
### chunk number 1: 
###################################################
#line 29 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
require("NMOF")
set.seed(112233)
tm <- c(c(1,3,6,9)/12,1:10)
betaTRUE <- c(6, 3, 8, 1)
yM <- NS(betaTRUE, tm)
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")


###################################################
### chunk number 2: 
###################################################
#line 45 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
OF <- function(param, data) {		
    y <- data$model(param, data$tm)
    aux <- y - data$yM
    aux <- max(abs(aux))
    if (is.na(aux)) aux <- 1e10
    aux
} 


###################################################
### chunk number 3: 
###################################################
#line 60 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
data <- list(
             yM = yM, 
             tm = tm,
          model = NS, 
             ww = 0.1,
            min = c( 0,-15,-30, 0), 
            max = c(15, 30, 30,10))


###################################################
### chunk number 4: 
###################################################
#line 74 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
param1 <- betaTRUE 
OF(param1, data)
param2 <- c(5.7, 3, 8, 2)
OF(param2, data)


###################################################
### chunk number 5: 
###################################################
#line 81 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
lines(tm, NS(param1, tm), col = "blue")
lines(tm, NS(param2, tm), col = "red")
legend(x = "topright", 
    legend = c("true yields", "param1", "param2"),
    col = c("black", "blue", "red"),
    pch = c(1, NA, NA), lty = c(0, 1, 1))


###################################################
### chunk number 6: 
###################################################
#line 93 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
penalty <- function(mP, data) {
    minV <- data$min
    maxV <- data$max
    ww <- data$ww
    # if larger than maxV, element in A is positiv
    A <- mP - as.vector(maxV); A <- A + abs(A)
    # if smaller than minV, element in B is positiv
    B <- as.vector(minV) - mP; B <- B + abs(B)
    # beta 1 + beta2 > 0
    C <- ww*((mP[1, ] + mP[2, ]) - abs(mP[1, ] + mP[2, ]))
    A <- ww * colSums(A + B) - C
    A
}


###################################################
### chunk number 7: 
###################################################
#line 110 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
param1 <- c( 6,3,8,-1)
param2 <- c( 6,3,8, 1)
param3 <- c(-1,3,8, 1)

mP <- cbind(param1,param2,param3)
rownames(mP) <- c("b1","b2","b3","lambda")
mP


###################################################
### chunk number 8: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
penalty(mP,data)


###################################################
### chunk number 9: 
###################################################
#line 125 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
data$ww <- 0.5
penalty(mP,data)


###################################################
### chunk number 10: 
###################################################
#line 131 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
param1 <- c( 6,3,8, 1)
param2 <- c( 6,3,8, 1)
param3 <- c( 2,3,8, 1)
mP <- cbind(param1,param2,param3)
rownames(mP) <- c("b1","b2","b3","lambda")
penalty(mP,data)


###################################################
### chunk number 11: 
###################################################
#line 143 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
# initialize algo settings
algo <- list(nP = 100L, 
             nG = 500L, 
              F = 0.50, 
             CR = 0.99,
            min = c( 0,-15,-30, 0), 
            max = c(15, 30, 30,10),
            pen = penalty, 
         repair = NULL,
         loopOF = TRUE, 
        loopPen = FALSE, 
     loopRepair = TRUE,
       printBar = FALSE)


###################################################
### chunk number 12: 
###################################################
#line 159 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
system.time(sol <- DEopt(OF = OF, algo = algo, data = data))


###################################################
### chunk number 13: 
###################################################
#line 164 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
max( abs(data$model(sol$xbest,tm) - data$model(betaTRUE,tm)) )
sol$OFvalue


###################################################
### chunk number 14: 
###################################################
#line 172 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
s0 <- algo$min + (algo$max-algo$min) * runif(length(algo$min))
system.time(sol2 <- nlminb(s0, OF, data = data,
                           lower = data$min, 
                           upper = data$max, 
                           control = list(eval.max = 50000L,
                                          iter.max = 50000L)))


###################################################
### chunk number 15: 
###################################################
#line 181 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
max(abs(data$model(sol2$par,tm)-data$model(betaTRUE,tm)))
sol2$objective	


###################################################
### chunk number 16: 
###################################################
#line 190 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years",
             ylab = "yields in %")
algo$printDetail <- FALSE
for (i in 1L:3L) {
    sol <- DEopt(OF = OF, algo = algo, data = data)
    lines(tm, data$model(sol$xbest,tm), col = "blue")
    s0 <- algo$min + (algo$max-algo$min) * runif(length(algo$min))
    sol2 <- nlminb(s0, OF, data = data,
                           lower = data$min, 
                           upper = data$max, 
                           control = list(eval.max = 50000L,
                                          iter.max = 50000L))

    lines(tm,data$model(sol2$par,tm), col = "darkgreen", lty = 2)
}

legend(x = "topright", legend = c("true yields", "DE", "nlminb"),
       col = c("black","blue","darkgreen"),
       pch = c(1, NA, NA), lty = c(0, 1, 2))


###################################################
### chunk number 17: 
###################################################
#line 220 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
tm <- seq(1, 10, length.out = 100)   # 1 to 10 years
betaTRUE <- c(3, -2, -8, 1.5)        # "true" parameters
yM <- NS(betaTRUE, tm)
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
abline(h = 0)


###################################################
### chunk number 18: 
###################################################
#line 231 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
penalty2 <- function(param,data) {
    y <- data$model(param,data$tm)
    aux <- abs(y - abs(y))
    sum(aux) * data$ww
}


###################################################
### chunk number 19: 
###################################################
#line 239 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
penalty2(c(3, -2, -8, 1.5),data)


###################################################
### chunk number 20: 
###################################################
#line 243 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
OFa <- function(param,data) {		
    y <- data$model(param,data$tm)
    aux <- y - data$yM
    res <- max(abs(aux))
    # compute the penalty
    aux <- y - abs(y) # aux == zero for nonnegative y 
    aux <- -sum(aux) * data$ww
    res <- res + aux
    if (is.na(res)) res <- 1e10
    res
}


###################################################
### chunk number 21: 
###################################################
#line 258 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
algo$pen <- NULL; data$yM <- yM; data$tm <- tm
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
abline(h = 0)
sol <- DEopt(OF = OFa, algo = algo, data = data)
lines(tm,data$model(sol$xbest,tm), col = "blue")
legend(x = "topleft", legend = c("true yields", "DE (constrained)"),
       col = c("black", "blue"),
       pch = c(1, NA, NA), lty = c(0, 1, 2))


###################################################
### chunk number 22: 
###################################################
#line 274 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
tm <- c(c(1,3,6,9)/12,1:10)
betaTRUE <- c(5,-2,5,-5,1,6)
yM <- NSS(betaTRUE, tm) 


###################################################
### chunk number 23: 
###################################################
#line 280 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
data <- list(yM = yM,
             tm = tm, 
          model = NSS,
            min = c( 0,-15,-30,-30,  0,5),
            max = c(15, 30, 30, 30,  5,  10),
             ww = 1)

algo <- list(nP = 100L,
             nG = 500L,
              F = 0.50,
             CR = 0.99,
            min = c( 0,-15,-30,-30,  0,5),
            max = c(15, 30, 30, 30,  5,  10),
            pen = penalty,
         repair = NULL,
         loopOF = TRUE, 
        loopPen = FALSE,
     loopRepair = TRUE,
       printBar = FALSE,
    printDetail = FALSE)


###################################################
### chunk number 24: 
###################################################
#line 303 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
system.time(sol <- DEopt(OF = OF, algo = algo, data = data))
max(abs(data$model(sol$xbest,tm) - data$model(betaTRUE,tm)))
sol$OFvalue

s0 <- algo$min + (algo$max - algo$min) * runif(length(algo$min))
system.time(sol2 <- nlminb(s0,OF,data = data,
                           lower = data$min, 
                           upper = data$max, 
                         control = list(eval.max = 50000L,
                                        iter.max = 50000L)))
max(abs(data$model(sol2$par,tm) - data$model(betaTRUE,tm)))
sol2$objective


###################################################
### chunk number 25: 
###################################################
#line 319 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
for (i in 1:3) {
    sol <- DEopt(OF = OF, algo = algo, data = data)
    lines(tm, data$model(sol$xbest,tm), col = "blue")
    s0 <- algo$min + (algo$max - algo$min) * runif(length(algo$min))
    sol2 <- nlminb(s0, OF, data = data,
                           lower = data$min, 
                           upper = data$max, 
                           control = list(eval.max = 50000L,
                                          iter.max = 50000L))

    lines(tm, data$model(sol2$par,tm), col = "darkgreen", lty = 2)
}

legend(x = "topright", legend = c("true yields", "DE", "nlminb"),
       col = c("black","blue","darkgreen"),
       pch = c(1,NA,NA), lty = c(0,1,2), bg = "white")


###################################################
### chunk number 26: 
###################################################
#line 345 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
cf1 <- c(rep(5.75,  8), 105.75); tm1 <- 0:8 + 0.5
cf2 <- c(rep(4.25, 17), 104.25); tm2 <- 1:18
cf3 <- c(3.5, 103.5); tm3 <- 0:1 + 0.5
cf4 <- c(rep(3.00, 15), 103.00); tm4 <- 1:16
cf5 <- c(rep(3.25, 11), 103.25); tm5 <- 0:11 + 0.5
cf6 <- c(rep(5.75, 17), 105.75); tm6 <- 0:17 + 0.5
cf7 <- c(rep(3.50, 14), 103.50); tm7 <- 1:15
cf8 <- c(rep(5.00,  8), 105.00); tm8 <- 0:8 + 0.5
cf9 <- 105; tm9 <- 1
cf10 <- c(rep(3.00, 12), 103.00); tm10 <- 0:12 + 0.5 
cf11 <- c(rep(2.50,  7), 102.50); tm11 <- 1:8
cf12 <- c(rep(4.00, 10), 104.00); tm12 <- 1:11
cf13 <- c(rep(3.75, 18), 103.75); tm13 <- 0:18 + 0.5 
cf14 <- c(rep(4.00, 17), 104.00); tm14 <- 1:18
cf15 <- c(rep(2.25,  8), 102.25); tm15 <- 0:8 + 0.5
cf16 <- c(rep(4.00,  6), 104.00); tm16 <- 1:7
cf17 <- c(rep(2.25, 12), 102.25); tm17 <- 1:13
cf18 <- c(rep(4.50, 19), 104.50); tm18 <- 0:19 + 0.5 
cf19 <- c(rep(2.25,  7), 102.25); tm19 <- 1:8
cf20 <- c(rep(3.00, 14), 103.00); tm20 <- 1:15


###################################################
### chunk number 27: 
###################################################
#line 370 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
cfList <- list(cf1,cf2,cf3,cf4,cf5,cf6,cf7,cf8,cf9,cf10,cf11,cf12,cf13,cf14,cf15,cf16,cf17,cf18,cf19,cf20)
tmList <- list(tm1,tm2,tm3,tm4,tm5,tm6,tm7,tm8,tm9,tm10,tm11,tm12,tm13,tm14,tm15,tm16,tm17,tm18,tm19,tm20)
tm <- unlist(tmList, use.names = FALSE)
tm <- sort(unique(tm))

# set up cashflow matrix
nR <- length(tm)
nC <- length(cfList)

cfMatrix <- array(0, dim = c(nR, nC))
for(j in seq(nC)) 
    cfMatrix[tm %in% tmList[[j]], j] <- cfList[[j]]
rownames(cfMatrix) <- tm

cfMatrix[1L:10L, 1L:10L]


###################################################
### chunk number 28: 
###################################################
#line 391 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
betaTRUE <- c(5,-2,1,10,1,3)
yM <- NSS(betaTRUE,tm)
diFa <- 1 / ( (1 + yM/100)^tm )
bM <- diFa %*% cfMatrix


###################################################
### chunk number 29: 
###################################################
#line 399 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
data <- list(bM = bM, 
             tm = tm, 
       cfMatrix = cfMatrix, 
          model = NSS, 
             ww = 1,
            min = c( 0,-15,-30,-30,0  ,2.5),
            max = c(15, 30, 30, 30,2.5,5  ))


###################################################
### chunk number 30: 
###################################################
#line 413 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
OF2 <- function(param, data) {			
    tm <- data$tm; bM <- data$bM
    model <- data$model; cfMatrix <- data$cfMatrix
    diFa  <- 1 / ((1 + model(param,tm)/100)^tm)
    b <- diFa %*% cfMatrix
    aux <- b - bM; aux <- max(abs(aux))
    if (is.na(aux)) aux <- 1e10
    aux
}


###################################################
### chunk number 31: 
###################################################
#line 426 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
algo <- list(
        nP  = 200L,
        nG  = 600L,
        F   = 0.50,
        CR  = 0.99,
        min	= c( 0,-15,-30,-30,0  ,2.5),
        max	= c(15, 30, 30, 30,2.5,5  ),
        pen = penalty,
        repair = NULL,
        loopOF = TRUE,
        loopPen = FALSE,
        loopRepair = FALSE,
        printBar = FALSE,
        printDetail = FALSE)

system.time(sol <- DEopt(OF = OF2, algo = algo, data = data))
# maximum yield error and value of OF
max(abs(data$model(sol$xbest,tm) - data$model(betaTRUE,tm)))
sol$OFvalue


###################################################
### chunk number 32: 
###################################################
#line 450 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
s0 <- algo$min + (algo$max - algo$min) * runif(length(algo$min))
system.time(sol2 <- nlminb(s0,OF2,data = data,
                                 lower = data$min, 
                                 upper = data$max, 
                               control = list(eval.max = 50000,
                                              iter.max = 50000)))
# maximum error yield and value of OF
max(abs(data$model(sol2$par,tm) - data$model(betaTRUE,tm)))
sol2$objective	

par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
lines(tm,data$model(sol$xbest,tm), col = "blue")
lines(tm,data$model(sol2$par,tm), col = "darkgreen", lty = 2)
legend(x = "bottom", legend = c("true yields", "DE", "nlminb"),
       col = c("black", "blue", "darkgreen"),
       pch = c(1, NA, NA), lty = c(0, 1, 2))


###################################################
### chunk number 33: 
###################################################
#line 471 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
# prices errors
diFa <- 1 / ((1 + NSS(sol$xbest,tm)/100)^tm)
b <- diFa %*% cfMatrix
b - bM


###################################################
### chunk number 34: 
###################################################
#line 479 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, NSS(sol$xbest,tm) - NSS(betaTRUE,tm), xlab = "maturities in years", ylab = "yield error in %")


###################################################
### chunk number 35: 
###################################################
#line 486 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(as.numeric(unlist(lapply(tmList, max))), as.vector(b - bM),
 xlab = "maturities in years", ylab = "price error in %")


###################################################
### chunk number 36: 
###################################################
#line 497 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
compYield <- function(cf,tm, guess = NULL) {
    fy <- function(ytm,cf,tm) sum( cf / ( (1+ytm)^tm ) )
    logik <- cf != 0 
    cf <- cf[logik]
    tm <- tm[logik]
    if(is.null(guess)) {ytm <- 0.05} else {ytm <- guess}
    h <- 1e-8;	dF <- 1; ci <- 0
    while (abs(dF) > 1e-5) {
        ci <- ci + 1; if(ci > 5) break
        FF <- fy(ytm,cf,tm)
        dFF <- (fy(ytm+h,cf,tm)-FF) / h
        dF <- FF / dFF
        ytm <- ytm - dF
    }
    if (ytm < 0) ytm <- 0.99
    return(ytm)
}


###################################################
### chunk number 37: 
###################################################
#line 518 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
OF3 <- function(param,data) {		
    tm <- data$tm; rM <- data$rM
    model <- data$model; cfMatrix<- data$cfMatrix
    nB <- dim(cfMatrix)[2L]
    zrates <- model(param,tm); aux <- 1e10
    if ( all(zrates > 0, !is.na(zrates)) ) {
        diFa <- 1 / ((1 + zrates/100)^tm)
        b <- diFa %*% cfMatrix
        r <- numeric(nB)
        if( all(!is.na(b), diFa < 1, diFa > 0, b > 1) ) { 
            # compute theoretical yields
            for (bb in 1:nB) {
                r[bb] <- compYield(c(-b[bb],cfMatrix[,bb]),c(0,tm))	
            }
            aux <- abs(r - rM)
            aux <- sum(aux)
        }
    }
    aux
}


###################################################
### chunk number 38: 
###################################################
#line 544 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
betaTRUE <- c(5,-2,1,10,1,3)
yM <- NSS(betaTRUE, tm)
diFa <- 1 / ( (1 + yM/100)^tm )
bM <- diFa %*% cfMatrix
rM <- apply(rbind(-bM, cfMatrix), 2, compYield, c(0, tm))


###################################################
### chunk number 39: 
###################################################
#line 553 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
data <- list(rM = rM, tm = tm, 
        cfMatrix = cfMatrix, 
        model = NSS, 
        min = c( 0,-15,-30,-30,0  ,2.5),
        max = c(15, 30, 30, 30,2.5,5  ), ww = 0.1)
algo <- list(
        nP = 50L,
        nG = 600L,
        F   = 0.50,
        CR  = 0.99,
        min = c( 0,-15,-30,-30,0  ,2.5),
        max = c(15, 30, 30, 30,2.5,5  ),
        pen = penalty,
        repair = NULL,
        loopOF = TRUE,
        loopPen = FALSE,
        loopRepair = FALSE, 
        printBar = FALSE,
        printDetail = FALSE)


###################################################
### chunk number 40: 
###################################################
#line 575 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
system.time(sol <- DEopt(OF = OF3, algo = algo, data = data))
max(abs(data$model(sol$xbest,tm) - data$model(betaTRUE,tm)))
sol$OFvalue


###################################################
### chunk number 41: 
###################################################
#line 582 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
s0 <- algo$min + (algo$max - algo$min) * runif(length(algo$min))
system.time(sol2 <- nlminb(s0, OF3, data = data,
                                   lower = algo$min, 
                                   upper = algo$max, 
                                 control = list(eval.max = 50000L,
                                                iter.max = 50000L)))
max(abs(data$model(sol2$par,tm)-data$model(betaTRUE,tm)))
sol2$objective	


###################################################
### chunk number 42: 
###################################################
#line 593 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
par(ps = 11, bty = "n", las = 1, tck = 0.01, mgp = c(3, 0.2, 0), mar = c(4, 4, 1, 1))
plot(tm, yM, xlab = "maturities in years", ylab = "yields in %")
lines(tm,data$model(sol$xbest,tm), col = "blue")
lines(tm,data$model(sol2$par,tm), col = "darkgreen", lty = 2)

legend(x  = "bottom", legend = c("true yields","DE","nlminb"),
        col = c("black", "blue", "darkgreen"),
        pch = c(1,NA,NA), lty = c(0,1,2))


###################################################
### chunk number 43: 
###################################################
#line 605 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/DEnss.Rnw"
betaTRUE
round(sol$xbest,3)


