###################################################
### chunk number 1: 
###################################################
#line 27 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
require("NMOF")
set.seed(112233)


###################################################
### chunk number 2: 
###################################################
#line 49 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
na <- 500L
C <- array(0.6, dim = c(na, na)); diag(C) <- 1
minVol <- 0.20; maxVol <- 0.40
Vols <- (maxVol - minVol) * runif(na) + minVol
Sigma <- outer(Vols, Vols) * C


###################################################
### chunk number 3: 
###################################################
#line 57 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
OF <- function(x, data) {
    xx <- as.logical(x)
    w <- x/sum(x)
    res <- crossprod(w[xx], data$Sigma[xx, xx])
    res <- tcrossprod(w[xx], res)
    res
}


###################################################
### chunk number 4: 
###################################################
#line 67 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
OF2 <- function(x, data) {
    xx <- as.logical(x); w <- 1/sum(x)
    res <- sum(w * w * data$Sigma[xx, xx])
    res
}


###################################################
### chunk number 5: 
###################################################
#line 75 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
neighbour <- function(xc, data) {
    xn <- xc
    p <- sample.int(data$na, data$nn, replace = FALSE)
    xn[p] <- abs(xn[p] - 1L)
    # reject infeasible solution
    if((sum(xn) > data$Ksup) || (sum(xn) < data$Kinf))
        xc else xn
}


###################################################
### chunk number 6: 
###################################################
#line 92 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
data <- list(Sigma = Sigma,
            Kinf = 30L,
              Ksup = 60L,
                na = na,
                nn = 1L)


###################################################
### chunk number 7: 
###################################################
#line 101 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
card0 <- sample(data$Kinf:data$Ksup, 1L, replace = FALSE)
assets <- sample.int(na, card0, replace = FALSE)
x0 <- numeric(na)
x0[assets] <- 1L


###################################################
### chunk number 8: 
###################################################
#line 112 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
## settings
algo <- list(x0 = x0,
      neighbour = neighbour,
             nS = 5000L,
    printDetail = FALSE,
       printBar = FALSE)


###################################################
### chunk number 9: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
system.time(sol1 <- LSopt(OF, algo, data))
sqrt(sol1$OFvalue)
par(ylog = TRUE, bty = "n", las = 1, tck = 0.01)
plot(sqrt(sol1$Fmat[,2L]),
     type = "l", xlab = "", ylab = "Portfolio volatility")


###################################################
### chunk number 10: 
###################################################
#line 132 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/LSselect.Rnw"
trials <- 5L
allRes <- restartOpt(LSopt, n = trials, OF, algo = algo, data = data)
allResOF <- numeric(trials)
for (i in seq_len(trials))
    allResOF[i] <- sqrt(allRes[[i]]$OFvalue)
par(bty = "n")
plot(ecdf(allResOF), main = "Portfolio volatility")


