###################################################
### chunk number 1: 
###################################################
#line 23 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
require("NMOF")
resample <- function(x, ...) x[sample.int(length(x), ...)]
set.seed(112233)


###################################################
### chunk number 2: 
###################################################
#line 50 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
na <- dim(fundData)[2L]
ns <- dim(fundData)[1L]
winf <- 0.0; wsup <- 0.05
data <- list(R = t(fundData),
            RR = crossprod(fundData),
            na = na,
            ns = ns,
           eps = 0.5/100,
          winf = winf,
          wsup = wsup)


###################################################
### chunk number 3: 
###################################################
#line 64 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
neighbour <- function(w, data){
    eps <- runif(1) * data$eps
    toSell <- w > data$winf
    toBuy  <- w < data$wsup
    i <- resample(which(toSell), size = 1L)
    j <- resample(which(toBuy), size = 1L)
    eps <- min(w[i] - data$winf, data$wsup - w[j], eps)
    w[i] <- w[i] - eps
    w[j] <- w[j] + eps
    w
}


###################################################
### chunk number 4: 
###################################################
#line 79 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
OF1 <- function(w, data) {
    Rw <- crossprod(data$R,w)
    crossprod(Rw)
}
OF2 <- function(w, data) {
    aux <- crossprod(data$RR,w)
    crossprod(w,aux)
}


###################################################
### chunk number 5: 
###################################################
#line 93 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
w0 <- runif(na); w0 <- w0/sum(w0)

algo <- list(x0 = w0,
      neighbour = neighbour,
             nS = 2000L,
             nT = 10L,
             nD = 5000L,
              q = 0.20,
       printBar = FALSE,
    printDetail = FALSE)

system.time(res <- TAopt(OF1,algo,data))
100*sqrt(crossprod(fundData %*% res$xbest)/ns)
system.time(res <- TAopt(OF2,algo,data))
100*sqrt(crossprod(fundData %*% res$xbest)/ns)

cat("Check constraints ...\n")
min(res$xbest); max(res$xbest); sum(res$xbest) # TA



###################################################
### chunk number 6: 
###################################################
#line 118 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
# benchmark
if (require(quadprog, quietly = TRUE)) {
  covMatrix <- crossprod(fundData)
  A <- rep(1, na); a <- 1
  B <- rbind(-diag(na),
              diag(na))
  b <- rbind(array(-data$wsup, dim = c(na,1)),
             array( data$winf, dim = c(na,1)))
  system.time({
      result <- solve.QP(Dmat = covMatrix,
                         dvec = rep(0,na),
                         Amat = t(rbind(A,B)),
                         bvec = rbind(a,b),
                          meq = 1L)
  })
  wqp <- result$solution

  cat("Compare results...\n")
  100 * sqrt( crossprod(fundData %*% wqp)/ns )
  100 * sqrt( crossprod(fundData %*% res$xbest)/ns )

  cat("Check constraints ...\n")
  min(wqp); max(wqp); sum(wqp)  # QP
}


###################################################
### chunk number 7: 
###################################################
#line 147 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
neighbourU <- function(sol, data){
    wn <- sol$w
    toSell <- wn > data$winf
    toBuy  <- wn < data$wsup
    i <- resample(which(toSell), size = 1L)
    j <- resample(which(toBuy), size = 1L)
    eps <- runif(1) * data$eps
    eps <- min(wn[i] - data$winf, data$wsup - wn[j], eps)
    wn[i] <- wn[i] - eps
    wn[j] <- wn[j] + eps
    Rw <- sol$Rw + data$R[,c(i,j)] %*% c(-eps,eps)
    list(w = wn, Rw = Rw)
}
OF <- function(sol, data) crossprod(sol$Rw)


###################################################
### chunk number 8: 
###################################################
#line 165 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
na <- dim(fundData)[2L]; ns <- dim(fundData)[1L]
winf <- 0.0; wsup <- 0.05
data <- list(R = fundData,
            na = na,
            ns = ns,
           eps = 0.5/100,
          winf = winf,
          wsup = wsup)


###################################################
### chunk number 9: 
###################################################
#line 178 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/TAportfolio.Rnw"
w0 <- runif(data$na); w0 <- w0/sum(w0)
x0 <- list(w = w0, Rw = fundData %*% w0)
algo <- list(x0 = x0,
      neighbour = neighbourU,
             nS = 2000L,
             nT = 10L,
             nD = 5000L,
              q = 0.20,
       printBar = FALSE,
    printDetail = FALSE)
system.time(res2 <- TAopt(OF,algo,data))
100*sqrt(crossprod(fundData %*% res2$xbest$w)/ns)


