###################################################
### chunk number 1: 
###################################################
#line 29 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
set.seed(112233)
options(digits = 3)


###################################################
### chunk number 2: 
###################################################
#line 42 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
up <- rep(1, 4L)
lo <- rep(0, 4L)
x <- rnorm(4L)
x


###################################################
### chunk number 3: 
###################################################
#line 49 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
repair1a <- function(x,up,lo) pmin(up,pmax(lo,x))
x
repair1a(x, up, lo)


###################################################
### chunk number 4: 
###################################################
#line 57 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
repair1b <- function(x, up, lo) {
    ii <- x > up
    x[ii] <- up[ii]
    ii <- x < lo
    x[ii] <- lo[ii]
    x
}
repair1c <- function(x, up, lo) {
    xadjU <- x - up
    xadjU <- xadjU + abs(xadjU)
    xadjL <- lo - x
    xadjL <- xadjL + abs(xadjL)
    x - (xadjU - xadjL)/2
}


###################################################
### chunk number 5: 
###################################################
#line 81 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
repair1a(x, up, lo)
repair1b(x, up, lo)
repair1c(x, up, lo)

trials <- 10000L
strials <- seq_len(trials)
system.time(for(i in strials) y1 <- repair1a(x, up, lo))
system.time(for(i in strials) y2 <- repair1b(x, up, lo))
system.time(for(i in strials) y3 <- repair1c(x, up, lo))


###################################################
### chunk number 6: 
###################################################
#line 94 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
X <- array(rnorm(25L), dim = c(5L, 5L))
X
repair1c(X, up = 0.5, lo = -0.5)


###################################################
### chunk number 7: 
###################################################
#line 103 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
pmax2 <- function(x1, x2) ( (x1 + x2) + abs(x1 - x2) ) / 2
pmin2 <- function(x1, x2) ( (x1 + x2) - abs(x1 - x2) ) / 2


###################################################
### chunk number 8: 
###################################################
#line 108 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
x1 <- rnorm(100L)
x2 <- rnorm(100L)

t1 <- system.time(for (i in strials) z1 <- pmax(x1,x2) )
t2 <- system.time(for (i in strials) z2 <- pmax2(x1,x2))
t1[[3L]]/t2[[3L]] ## speedup
all.equal(z1, z2)

t1 <- system.time(for (i in strials) z1 <- pmin(x1,x2) )
t2 <- system.time(for (i in strials) z2 <- pmin2(x1,x2))
t1[[3L]]/t2[[3L]] ## speedup
all.equal(z1, z2)


###################################################
### chunk number 9: 
###################################################
#line 130 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
repair2 <- function(x,up,lo) {
    done <- TRUE
    e <- sum(x - up  + abs(x - up) + lo - x  + abs(lo - x))
    if (e > 1e-12) done <- FALSE
    r <- up - lo
    while (!done) {
        adjU <- x - up
        adjU <- adjU + abs(adjU)
        adjU <- adjU + r - abs(adjU - r)

        adjL <- lo - x
        adjL <- adjL + abs(adjL)
        adjL <- adjL + r - abs(adjL - r)

        x <- x - (adjU - adjL)/2
        e <- sum(x - up  + abs(x - up) + lo - x  + abs(lo - x))
        if (e < 1e-12) done <- TRUE
    }
    x
}
x
repair2(x, up, lo)
system.time(for (i in strials) y4 <- repair2(x,up,lo))


###################################################
### chunk number 10: 
###################################################
#line 158 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
T <- 20L
x <- logical(T)
x[runif(T) < 0.4] <- TRUE
x


###################################################
### chunk number 11: 
###################################################
#line 166 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
kmax <- 5L
kmin <- 3L


###################################################
### chunk number 12: 
###################################################
#line 172 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
resample <- function(x, ...) x[sample.int(length(x), ...)]
repairK <- function(x, kmax, kmin) {
    sx <- sum(x)
    if (sx > kmax) {
        i <- resample(which(x), sx - kmax)
        x[i] <- FALSE
    } else if (sx < kmin) {
        i <- resample(which(!x), kmin - sx)
        x[i] <- TRUE
    }
    x
}
printK <- function(x)
    cat(paste(ifelse(x, "o", "."), collapse = ""),
        "-- cardinality", sum(x), "\n")


###################################################
### chunk number 13: 
###################################################
#line 190 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
for (i in 1:10) {
    if (i==1L) printK(x)
    x1 <- repairK(x, kmax, kmin)
    printK(x1)
}


###################################################
### chunk number 14: 
###################################################
#line 198 "d:/Rcompile/CRANpkg/local/2.12/NMOF/inst/doc/repair.Rnw"
x <- logical(T); x[10L] <- TRUE
for (i in 1:10) {
    if (i==1L) printK(x)
    x1 <- repairK(x, kmax, kmin)
    printK(x1)
}


